//---------------------------------------------------------------------------
#include <vcl.h>
#include <inifiles.hpp>
#pragma hdrstop

#include "Unit1.h"
#include   <stdio.h>
#include   <dos.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "XComDrv"
#pragma link "CSPIN"
#pragma link "XComDrv"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  	TIniFile *ini;
	ini = new TIniFile(
      ChangeFileExt( Application->ExeName, ".INI" ) );
	XComm1->DeviceName = ini->ReadString("Comport","DeviceName","COM1");
	delete ini;
	ComPort->ItemIndex = (XComm1->DeviceName[4])-49;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
	TIniFile *ini;
   ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
	ini->WriteString("Comport","DeviceName", XComm1->DeviceName);
   delete ini;

   if(XComm1->Opened)
  		XComm1->CloseDevice();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::XComm1Data(TObject *Sender, const DWORD Received)
{
  int len, i, days, w;
  char ds[25];
  unsigned short year,month,day;
  TDateTime dt;


  s = "";
  len = 0;
  days = 0;
  w  = 0;
  
  if(Received == 0)
    return;
  len = XComm1->ReadData(&buffer[index], Received);
  index += len;
  RBytes->Caption = index;

  // Analyse received bytes
  if((buffer[0] == 0x11)&&(index == 6))   // Data Block from WR
  {
    for(i=0; i < index; i++)
    {
      s = s.IntToHex((int)buffer[i],2);
      Memo1->Lines->Add(s);
      s = "";
    }
    Leistung->Caption   = buffer[1]*110/8;
    SolarU->Caption     = buffer[2]*4/3;
    NetzU->Caption      = buffer[3];
    Temperatur->Caption = (buffer[4] - 180)*3/2;
    index = 0;
  }
  else
  {
  if(index == 0xFF)   // Data from Logger received
  {
    for(i=0; i < 0xFF; i++)
    {    
      s = s.IntToHex((int)buffer[i],2);
      Memo2->Lines->Add(s);
      s = "";
    }
    index = 0;

    days = (buffer[0]-2)/2;
    Tage->Caption = days;

    if ((buffer[1]==0)||(buffer[2]==0))
    {
    	buffer[2] = 1;
    	buffer[1] = 1;
      Application->MessageBox("Datum ist nicht OK!!!", "Achtung!!", MB_OK);
    }
    DecodeDate(Date(),year, month, day);
    sprintf(ds,"%02u.%02u.%4u",buffer[2],buffer[1],year);
    Datum->Caption = ds;
    Memo3->Lines->Add(ds);
    Series1->Clear();
    dt = EncodeDate(year,buffer[1],buffer[2]);
    for(i=0; i < days; i++)
    {
      w = buffer[(i*2)+4];
      w = w << 8;
      w = w + buffer[(i*2)+3];
      sprintf(ds,"%u",w);
      Memo3->Lines->Add(ds);
      Series1->AddXY(dt+i,w,"",clTeeColor);
    }
  
  }
  if(index > 0xFF)
    // forget the rest
    index = 0;
  }
  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  struct time t;
  struct date d;

  gettime(&t);
  getdate(&d);
  XComm1->SendByte('\0');    // Trigger Byte
  XComm1->SendByte('\2');    // Cmd Byte SETTIME

  if(CheckBox1->Checked)
  {
    XComm1->SendByte(hour->Value);
    XComm1->SendByte(minute->Value);
  }
  else
  {
    XComm1->SendByte(t.ti_hour);
    XComm1->SendByte(t.ti_min);
  }
  XComm1->SendByte(t.ti_sec);
  XComm1->SendByte(d.da_mon);
  XComm1->SendByte(d.da_day);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
	Memo2->Clear();
   Memo3->Clear();
	XComm1->SendByte('\0');    // Trigger Byte
	XComm1->SendByte('\1');    // Cmd Byte  GETDATA
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
	if(Application->MessageBox("Daten wirklich lschen?", "Achtung!!", MB_YESNO) != IDYES)
   	return;
  	XComm1->SendByte('\0');    // Trigger Byte
  	XComm1->SendByte('\3');    // Cmd Byte  CLEAREEPROM 
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComPortClick(TObject *Sender)
{
  if(XComm1->Opened)
    XComm1->CloseDevice();
  XComm1->DeviceName = ComPort->Items->Strings[ComPort->ItemIndex];
  try
  {
    XComm1->OpenDevice();
  }
  catch (...){Application->MessageBox("Could not open device","",MB_OK);}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
  struct time t;
  struct date d;

  if(Application->MessageBox("Wollen Sie wirklich einen RESTART?", "Achtung!!", MB_YESNO) != IDYES)
  	return;
  gettime(&t);
  getdate(&d);
  XComm1->SendByte('\0');    // Trigger Byte
  XComm1->SendByte('\4');    // Cmd Byte RESTART

  if(CheckBox1->Checked)
  {
    XComm1->SendByte(hour->Value);
    XComm1->SendByte(minute->Value);
  }
  else
  {
    XComm1->SendByte(t.ti_hour);
    XComm1->SendByte(t.ti_min);
  }
  XComm1->SendByte(t.ti_sec);
  XComm1->SendByte(d.da_mon);
  XComm1->SendByte(d.da_day);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  if(CheckBox1->Checked)
  {
    hour->Enabled      = true;
    minute->Enabled    = true;
  }
  else
  {
    hour->Enabled      = false;
    minute->Enabled    = false;
  }  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  Memo1->Clear();  
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button8Click(TObject *Sender)
{
  SaveDialog1->FileName = "WR-Logfile_" + Datum->Caption;
  if(SaveDialog1->Execute()) 
  {
    try
    {
      Memo3->Lines->SaveToFile(SaveDialog1->FileName);
    }
    catch(...){;}
  }
}
//---------------------------------------------------------------------------




void __fastcall TForm1::Button6Click(TObject *Sender)
{
	int w;


	Memo3->Clear();
   Series1->Clear();
	if(OpenDialog1->Execute())
   {
   	try
      {
   		Memo3->Lines->LoadFromFile(OpenDialog1->FileName);
         TDateTime dt(Memo3->Lines->Strings[0]);
         for(int i=1; i < Memo3->Lines->Count; i++)
         {
         	w = Memo3->Lines->Strings[i].ToInt();
            Series1->AddXY(dt+i-1,w,"",clTeeColor);
         }
      }
      catch(...){;}
   }
}
//---------------------------------------------------------------------------

